"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function stripUnusedPropertiesFromProperty(val) {
    if (val.type === 'object') {
        stripUnusedPropertiesMap(val.properties);
        val.functions = stripUnusedProperties(val.functions);
    }
    else if (val.type === 'choices' && val.choices)
        val.choices = stripUnusedProperties(val.choices);
    if (val.type === 'function')
        val.parameters = stripUnusedProperties(val.parameters);
    if (val.$ref === 'contextMenusInternal.OnClickData')
        val.$ref = 'OnClickData';
    else if (val.$ref === 'UnrecognizedProperty')
        val.$ref = 'any';
    else if (val.$ref === 'PersistentBackgroundProperty')
        val.$ref = 'boolean';
}
function stripUnusedProperties(values) {
    if (values) {
        values = values.filter((v) => !v.unsupported && !v.deprecated);
        values.forEach(stripUnusedPropertiesFromProperty);
    }
    return values;
}
function stripUnusedPropertiesMap(map) {
    if (map) {
        for (const key in map) {
            const val = map[key];
            if (val.unsupported || val.deprecated)
                delete map[key];
            else
                stripUnusedPropertiesFromProperty(val);
        }
    }
}
function stripUnusedContent(value) {
    value.events = stripUnusedProperties(value.events);
    value.functions = stripUnusedProperties(value.functions);
    value.types = stripUnusedProperties(value.types);
    stripUnusedPropertiesMap(value.properties);
}
exports.stripUnusedContent = stripUnusedContent;
//# sourceMappingURL=stripUnusedContent.js.map