#! /usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const readSchemaFile_1 = require("./helpers/readSchemaFile");
const types_1 = require("./helpers/types");
const assert_1 = require("./helpers/assert");
function validateJson(data) {
    try {
        console.log(data.file);
        assert_1.assertArray(data.json, types_1.SchemaEntry.validate);
    }
    catch (e) {
        console.error('Error reading ' + data.file + ': ', e);
        throw e;
    }
}
try {
    const files = fs.readdirSync('./schemas');
    files.map(readSchemaFile_1.readSchemaFile).forEach(validateJson);
    console.log('--------------------');
    console.log('All files are valid!');
}
catch (e) {
}
//# sourceMappingURL=validate.js.map